#include "MainPage.h"
#include "includes.h"



void unifiedMenu(void){
    //1 title, ITEM_PER_PAGE items(icon+label)
MENUITEMS unifiedPageItems = {
  // title
  LABEL_MAINMENU,
  // icon               label
  {{ICON_HEAT_FAN,    LABEL_UNIFIEDHEAT},
    {ICON_HOME_MOVE,  LABEL_UNIFIEDMOVE},
    {ICON_EXTRUDE,    LABEL_EXTRUDE},
    {ICON_STOP,       LABEL_EMERGENCYSTOP},
    {ICON_GCODE,      LABEL_TERMINAL},
    {ICON_CUSTOM,     LABEL_CUSTOM},
    {ICON_SETTINGS,   LABEL_SETTINGS},
    {ICON_BACK,       LABEL_BACK}}
  };

  KEY_VALUES key_num = KEY_IDLE;
  GUI_SetBkColor(infoSettings.bg_color);

  menuDrawPage(&unifiedPageItems);

  while(infoMenu.menu[infoMenu.cur] == unifiedMenu)
  {
    key_num = menuKeyGetValue();
    switch(key_num)
    {
      case KEY_ICON_0: infoMenu.menu[++infoMenu.cur] = menuUnifiedHeat;     break;
      case KEY_ICON_1: infoMenu.menu[++infoMenu.cur] = menuUnifiedMove;     break;
      case KEY_ICON_2: infoMenu.menu[++infoMenu.cur] = menuExtrude;         break;
      case KEY_ICON_3: storeCmd("M112\n"); break;     // Emergency Stop : Used for emergency stopping, a reset is required to return to operational mode.
                                                      // it may need to wait for a space to open up in the command queue.
                                                      // Enable EMERGENCY_PARSER in Marlin Firmware for an instantaneous M112 command.
      case KEY_ICON_4: infoMenu.menu[++infoMenu.cur] = menuSendGcode;       break;
      case KEY_ICON_5: infoMenu.menu[++infoMenu.cur] = menuCustom;          break;
      case KEY_ICON_6: infoMenu.menu[++infoMenu.cur] = menuSettings;        break;
      case KEY_ICON_7: infoMenu.cur--;        break;
      default:break;
    }
    loopProcess();
    }
}

void classicMenu(void)
{
  //1 title, ITEM_PER_PAGE items(icon+label)
  MENUITEMS classicPageItems = {
  // title
  LABEL_READY,
  // icon             label
    {{ICON_MOVE,     LABEL_MOVE},
      {ICON_HOME,     LABEL_HOME},
      {ICON_ZERO,     LABEL_ZERO},
      {ICON_PRINT,    LABEL_PRINT},
      {ICON_SETTINGS, LABEL_SETTINGS},
      {ICON_STEPPERS_ON, LABEL_STEPPERS_ON},
      {ICON_STEPPERS_OFF, LABEL_STEPPERS_OFF},
      {ICON_GCODE, LABEL_TERMINAL}}
  };

  KEY_VALUES key_num=KEY_IDLE;
  GUI_SetBkColor(infoSettings.bg_color);

  menuDrawPage(&classicPageItems);

  while(infoMenu.menu[infoMenu.cur] == classicMenu)
  {
    key_num = menuKeyGetValue();

    switch(key_num)
    {
      case KEY_ICON_0: infoMenu.menu[++infoMenu.cur] = menuMove;      break;
      case KEY_ICON_1: infoMenu.menu[++infoMenu.cur] = menuHome;      break;
      case KEY_ICON_2: infoMenu.menu[++infoMenu.cur] = menuZero;      break;
      case KEY_ICON_3: infoMenu.menu[++infoMenu.cur] = menuPrint;     break;
      case KEY_ICON_4: infoMenu.menu[++infoMenu.cur] = menuSettings;   break;
      case KEY_ICON_5: storeCmd("M17\n");   break; // turn on all steppers to lock position
      case KEY_ICON_6: storeCmd("M18\n");   break; // turn off all steppers
      case KEY_ICON_7: infoMenu.menu[++infoMenu.cur] = menuSendGcode; break;
    
      default:break;
    }
    loopProcess();
  }
}
